/* Problem URL: https://codeforces.com/contest/2094/problem/H */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int inf = INT32_MAX >> 1;

static vvi vec(1e5 + 1);

struct persistent_vector {
    set<int> used;

    void insert(int num, int i) {
        used.insert(num);
        vec[num].push_back(i);
    }

    int get(int num, int i) {
        auto itr = lower_bound(all(vec[num]), i);
        if (itr == vec[num].end()) {
            return inf;
        }

        return *itr;
    }

    ~persistent_vector() {
        for (auto i : used) {
            vec[i].clear();
        }
    }
};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vvi muls(1e5 + 1);
    nrep(i, 2, 1e5 + 1) {
        for (int j = i; j <= 1e5; j += i) {
            muls[j].push_back(i);
        }
    }

    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;

        vi nums(n);
        cin >> nums;

        persistent_vector divs;
        rep(i, n) {
            divs.insert(nums[i], i);
        }

        while (q--) {
            ll k, l, r;
            cin >> k >> l >> r;

            l--, r--;

            int now = l;
            ll ans = 0;
            while (now <= r) {
                ll tmp = inf;
                for (auto i : muls[k]) {
                    rmin(tmp, (ll)divs.get(i, now));
                }
                rmin(tmp, r);
                ans += k * (tmp - now);
                while (k % nums[tmp] == 0) {
                    k /= nums[tmp];
                }

                now = tmp + 1;
                ans += k;

                if (k == 1) {
                    ans += r - now + 1;
                    break;
                }
            }

            cout << ans << '\n';
        }
    }
}
